/*
Very basic emulation of fixed function pipeline
Marijn Kentie 2009
*/

#include "header.fxh"


//--------------------------------------------------------------------------------------
// Vertex Shader
//--------------------------------------------------------------------------------------
PS_INPUT VS( VS_INPUT input )
{
    PS_INPUT output = (PS_INPUT)0;
    output.origPos = input.pos;
    output.pos = mul( input.pos, World );
    output.pos = mul( output.pos, View );
    output.pos = mul( output.pos, Projection );
    output.color = input.color;
	output.tex = input.tex;
	output.normal = input.normal;
	
    return output;
}


//--------------------------------------------------------------------------------------
// Pixel Shader
//--------------------------------------------------------------------------------------
float4 PS( PS_INPUT input) : SV_Target
{
	return float4(input.origPos,1);
}


//--------------------------------------------------------------------------------------
technique10 Render
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( NULL );
        SetPixelShader( CompileShader( ps_4_0, PS() ) );
		SetRasterizerState(Wireframe);
    }
}