/*
Marijn Kentie 2009
*/

//Variables
cbuffer rarely
{
	matrix Projection;	
}

cbuffer eachFrame
{
	matrix World;
	matrix View;
	float3 Eye;
}

//Textures
Texture2D textureDiffuse;
Texture2D textureHeightMap;

//Samplers
SamplerState samLinear
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

SamplerState samLinearClamp
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;

};

//Structures

struct VS_INPUT
{
    float4 pos : POSITION;
	float4 color: COLOR;
	float3 normal: NORMAL;
	float3 tex: TEXCOORD;
};

struct PS_INPUT
{
    float4 pos : SV_POSITION;
	float4 color: COLOR;
	float3 normal: NORMAL;
	float3 tex : TEXCOORD0;
	float3 eye: TEXCOORD2;
	float3 origPos: TEXCOORD3;
	float3 lightPos: TEXCOORD4;
};

struct PS_OUTPUT
{
	float4 color : SV_TARGET;
	float  depth : SV_DEPTH;        
};

//States
DepthStencilState EnableDepth
{
    DepthEnable = TRUE;
    DepthWriteMask = ALL;
    DepthFunc = LESS_EQUAL;
};

RasterizerState Wireframe
{
    CullMode = BACK;
    FillMode = WIREFRAME;
};
RasterizerState Default
{
    CullMode = BACK;
    FillMode = SOLID;
};