#include <windows.h>

#include "input.h"
#include "camera.h"
#include "window.h"
#include <stdio.h>
#include "d3d.h"

static POINT oldPos; //Old cursor position absolute to screen
static POINT oldClientPos; //Cursor position relative to client area
	static bool ignore;

//Process keypresses using a virtual key code
void Input::keyDown(unsigned int vCode)
{
	switch(vCode)
	{
		case VK_ESCAPE:
			PostQuitMessage(0);
			break;
		case 'W':
			Camera::translate(Camera::Z,Camera::NEG);
			break;
		case 'S':
			Camera::translate(Camera::Z,Camera::POS);
			break;
		case 'A':
			Camera::translate(Camera::X,Camera::POS);
			break;
		case 'D':
			Camera::translate(Camera::X,Camera::NEG);
			break;
		case 'Q':
			Camera::rotate(Camera::Z,Camera::POS);
			break;
		case 'E':
			Camera::rotate(Camera::Z,Camera::NEG);
			break;
		case VK_SPACE:
			Camera::translate(Camera::Y,Camera::NEG);
			break;
		case VK_CONTROL:
			Camera::translate(Camera::Y,Camera::POS);
			break;

		case 'C':
			D3D::addCraters();
			break;
		case 'B':
			D3D::toggleSetting(D3D::BINARY_SEARCH);
			break;
		case 'M':
			D3D::toggleSetting(D3D::DEFORMATION);
			break;
		case 'L':
			D3D::toggleSetting(D3D::LIGHTING);
			break;
		case 'T':
			D3D::toggleSetting(D3D::TERRAIN);
			break;
		case 'O':
			D3D::toggleSetting(D3D::OCCLUSION);
			break;
		case 'R':
			D3D::toggleSetting(D3D::DYNAMIC_SAMPLE);
			break;
	}

}

void Input::mouseButton(int button,int state, int x, int y)
{
	if(button==1)//Right button
	{
		int centerX=Window::getX()+Window::getWidth()/2;
		int centerY=Window::getY()+Window::getHeight()/2;
		if(state==1)
		{
			RECT clip;
			clip.left = centerX-1;
			clip.right = centerX+2;
			clip.top = centerY-1;
			clip.bottom = centerY+2;
			SetCursorPos(centerX,centerY);
			ignore = true;
		//	ShowCursor(0);			
		}
		else
		{
		
		
			
			ShowCursor(1);
		}
	}
}

void Input::mouseMove(int x, int y,bool lButton, bool rButton)
{

	
		int centerX=Window::getX()+Window::getWidth()/2;
		int centerY=Window::getY()+Window::getHeight()/2;
		POINT pos;
		GetCursorPos(&pos);
		x=pos.x;
		y=pos.y;

		if(ignore)
		{
			ignore=false;
			return;
		}

		if(rButton==1)
		{
			
			if(x!= centerX||y!= centerY)
			{
				ignore=true;
				SetCursorPos(centerX,centerY);
				if(y<centerY)
				{
					Camera::rotate(Camera::X,Camera::NEG);
					
				}
				else if(y>centerY)
				{
					Camera::rotate(Camera::X,Camera::POS);
				
				}
				
				if(x<centerX)
				{
		
					Camera::rotate(Camera::Y,Camera::NEG);
					
				}
				else if(x>centerX)
				{
					Camera::rotate(Camera::Y,Camera::POS);
					
				}

				
				
			}
		}
	

}