#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <FCNTL.H>

#include "main.h"
#include "window.h"
#include "d3d.h"
#include "camera.h"

VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
D3D::render();

}



int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	//Spawn a console and redirect stdout to it
	AllocConsole();
	stdout->_file = _open_osfhandle((long)GetStdHandle(STD_OUTPUT_HANDLE),_O_TEXT);

	//Create window
	puts("Starting...");
	puts("Controls: WASD, space, ctrl - move \n Mouse right button down + mouse move - look \n C - deform terrain \n T - toggle terrain \n D - toggle deformations \n L - toggle lighting \n B - toggle binary search \n O - toggle occlusion \n R - toggle dynamic sample rate \n");
	if(!Window::create(hInstance,nCmdShow))
	{
		puts("Error creating window.");
		FreeConsole();
		return 0;
	}

	//Set up direct3d
	if(!D3D::init())
	{
  		puts("Error initializing Direct3D.");
		FreeConsole();
		D3D::cleanup();
		return 0;
	}
	Camera::init();

	puts("Started.");

	SetTimer(Window::getHWND(),1,10,&TimerProc);
	// Main message loop
	MSG msg = {0};
	while( WM_QUIT != msg.message )
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else
		{
		//	D3D::render();
		}
	}

	D3D::cleanup();
	FreeConsole();
	return 0;
}