//Shaders for a skybox pass; resize and texture the unit cube.

TextureCube textureSkybox;

PS_INPUT VS_sky( VS_INPUT input )
{
	PS_INPUT output = (PS_INPUT)0;
	output.origPos=input.pos;
	//Expand box
	output.pos = input.pos-0.5f;
	output.pos.x*=10.0f;
	output.pos.z*=10.0f;
	
	//Strip out translation
	matrix View2 = View;
	View2[3][0]=0;
	View2[3][1]=0;
	View2[3][2]=0;
	
	//Standard transforms
	output.pos = mul( output.pos, View2 );	
    output.pos = mul( output.pos, Projection );
    output.color = input.color;
    
	//Generate cubemap coordinates    
    output.tex = -1+output.origPos*2;
    return output;
}

float4 PS_sky( PS_INPUT input) : SV_Target
{	
	return textureSkybox.Sample(samLinearClamp,input.tex);
}