//Shrinks and translates a box so it can be put somewhere in a scene

//Rasterizer state to cull front faces, effectively turning the box inside out
RasterizerState RasSmallbox
{
	CullMode=FRONT;
};

PS_INPUT VS_smallbox( VS_INPUT input )
{
	PS_INPUT output = (PS_INPUT)0;
	output.origPos=input.pos;
	
	//Shrink box
	output.pos = input.pos;
	output.pos.xyz *= 0.25f;
	output.pos.z+=0.5f;
		
	//Standard transforms
	output.pos = mul( output.pos, View );	
    output.pos = mul( output.pos, Projection );
    output.color = input.color; 
    return output;
}

float4 PS_smallbox( PS_INPUT input) : SV_Target
{	
	return float4(input.origPos,0.5f);
}