/*
Use sobel filter to calculate texture derivatives and from that normal
Idea from Tatarchuk-POM
Based on code from http://catalinzima.spaces.live.com/?_c11_BlogPart_BlogPart=blogview&_c=BlogPart&partqs=cat%3DHLSL
*/

 
float4 ComputeNormalsPS(Texture2D tex, float2 uv)
{
	float h,w;
	tex.GetDimensions(h,w);
	float texelSize =  1.0f / h ; //size of one texel;
	float normalStrength = 8;
	float tl = abs(tex.SampleLevel(samLinear, uv + texelSize * float2(-1, -1),0).x);   // top left
	float  l = abs(tex.SampleLevel(samLinear, uv + texelSize * float2(-1,  0),0).x);   // left
	float bl = abs(tex.SampleLevel(samLinear, uv + texelSize * float2(-1,  1),0).x);   // bottom left
	float  t = abs(tex.SampleLevel(samLinear, uv + texelSize * float2( 0, -1),0).x);   // top
	float  b = abs(tex.SampleLevel(samLinear, uv + texelSize * float2( 0,  1),0).x);   // bottom
	float tr = abs(tex.SampleLevel(samLinear, uv + texelSize * float2( 1, -1),0).x);   // top right
	float  r = abs(tex.SampleLevel(samLinear, uv + texelSize * float2( 1,  0),0).x);   // right
	float br = abs(tex.SampleLevel(samLinear, uv + texelSize * float2( 1,  1),0).x);   // bottom right
 
	// Compute dx using Sobel:
	//           -1 0 1 
	//           -2 0 2
	//           -1 0 1
	float dX = tr + 2*r + br -tl - 2*l - bl;
 
	// Compute dy using Sobel:
	//           -1 -2 -1 
	//            0  0  0
	//            1  2  1
	float dY = bl + 2*b + br -tl - 2*t - tr;
 
	// Build the normalized normal
	float4 N = float4(normalize(float3(dX, 1.0f / normalStrength, dY)), 1.0f);
 
	//convert (-1.0 , 1.0) to (0.0 , 1.0), if needed
	return N * 0.5f + 0.5f;
	return float4(0,0,0,0);
}